/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_DRAW_STRUCT_H__
#define __MTK_DRAW_STRUCT_H__
#include  <windows.h>
#include  "../common/math/vector3.h"
#include  "mtk_text.h"
#include  "mtk_screen.h"
#include  "mtk_camera.h"
#include  "mtk_target.h"




//-------------------
//  `p̍\
//-------------------
class mtk_draw_struct
{
public:
	// W王_Wւ̕ϊiXP[O܂ށj
	matrix3d	M_view;
	vector3d	r_view;



	double		JD;					// iEXj  //***

	double		scale;				// XP[(pc)
	double		scale_factor;		// XP[q

	float		plnt_R, plnt_angle;
	
	mtk_camera	camera_base;		// x[XJ
	mtk_camera	camera;				// `ɎgpJ

	vector3d	target_pos;			// ^[Qbg̈ʒu

	mtk_target	tgt;

	int			w, h;				// r[|[g̃TCY

	frustum		frs;				// Frustum

	char		lang;				// 

	float		rad_per_pixel;		// 1sNZ̊pxiWAPʁj
	float		ltf;				// ̑ΓITCY *** ij

private:
	bool		bNear;

public:
	mtk_draw_struct()	{};

	void	set(const mtk_camera& _camera, const double& _JD, int _w, int _h, const float font_size);

	vector3d	calc_pos_on_viewframe(const vector3d& pos) const	{ return  M_view * pos + r_view; }

	void	set_near_region()		{ frs = get_frustum_near(w, h); bNear = true;  }
	void	set_far_region()		{ frs = get_frustum_far(w, h);  bNear = false; }
	bool	is_near_region() const	{ return bNear; }
};


#endif
