/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_MINOR_PLANETS_H__
#define __MTK_MINOR_PLANETS_H__
#include  <stdio.h>
#include  "mtk_draw_struct.h"
#include  "mtk_space_curve.h"


const int SMALLOBJ_TYPE_NUM = 2;


int			get_small_objects_type_num();
int			load_small_objects(FILE* fp, int type);
void		load_small_object_names(FILE* fp);
void		register_small_objects();
int			get_small_objects_num();
void		update_small_objects_position(const double& t);
vector3d	get_small_object_position(int idx);
int			get_small_object_type(int idx);
bool		is_small_object_selected(int idx);
int			get_small_object_label_index(int idx);
void		get_small_object_size(int idx, double& Rx, double& Ry, double& Rz);
int			get_small_object_index(int minor_planet_number);
void		draw_a_small_object0(int idx);
void		draw_a_small_object(const mtk_draw_struct& ds, int idx, vector3d rpos, double scl);
void		draw_small_objects(const mtk_draw_struct& ds);
void		register_small_objects_orbit_curves();
void		make_small_objects_orbit_curve(space_curve& sc, int div_N);
float		get_small_object_label_alpha(const mtk_draw_struct& ds, int idx);
float		get_small_object_orbit_alpha(const mtk_draw_struct& ds, int idx);
double		calc_visible_radius_small_object(int idx);


enum {
	SMALLOBJ_TYPE_MINOR_PLANETS,
	SMALLOBJ_TYPE_TNOS
};


#endif
