/******************************************************************************

Copyright (c) 2007   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEF
Avj̕擾邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ
܂Bɂ́A\tgEFA̕gpAʁAύXAAfځAЕzATu
CZXA/܂͔̔錠Aу\tgEFA񋟂鑊ɓ
Ƃ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕ
Lڂ̂Ƃ܂B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂
񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KAьN
QɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂܂B ҂܂͒
쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\tgEFAɋN܂
֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
*******************************************************************************/
#ifndef __WGL_FONT_H__
#define __WGL_FONT_H__
#include  <windows.h>
#include  <gl/gl.h>
#include  <map>
using namespace std;
#include  <string.h>
#include  <mbctype.h>
#include  "../bilingual.h"


//-----------------
//  }`oCg
//-----------------
inline  bool
isMB(char ch1, char ch2)
{
	return  (_ismbblead(ch1) && _ismbbtrail(ch2));
}

inline  unsigned
get_MB_code(char ch1, char ch2)
{
	unsigned  u1, u2;
	u1 = (unsigned char)ch1;
	u2 = (unsigned char)ch2;
	return  (u1<<8) | u2;
}


//-----------------
// Ot̍\
//-----------------
struct glyph_info {
	GLuint  disp_list_idx;
	float	BlackBoxX, BlackBoxY;
	float   CellIncX, CellIncY;
};


//===========================
//  WGL ŃtHgNX
//===========================
template <class T>
class wglFont
{
	map<T, glyph_info>	gi;			// Ot
	char				szFaceName[256];	// tHg̃tFCXl[
	BYTE				CharSet;	// tHg̃LN^Zbg
	bool				bPolygon;	// |S
public:
	wglFont(const char* _szFaceName) : CharSet(DEFAULT_CHARSET), bPolygon(true) { strcpy(szFaceName, _szFaceName); }
	void	set_face_name(const char* _szFaceName)	{ strcpy(szFaceName, _szFaceName); }
	void	set_polygon_mode(bool flg)	{ bPolygon=flg; }				// |S[hZbg
	bool	regist(const T& code);										// Po^
	void	draw_char(const T& code);									// P\
	void	get_glyph_size(const T& code, float& w, float& h);
	void	get_glyph_size2(const T& code, float& w2, float& h2);
private:
	bool	regist_if_not(const T& code);
};


//-- P𕶎f[^x[XOpenGLfBXvCXgɓo^
template <class T>
bool
wglFont<T>::regist(const T& code)
{
	HDC  hDC;
	HFONT  hFont, hOldFont;
	LOGFONT lf;
	hDC = CreateCompatibleDC(NULL);		if (hDC==0)  return false;

	// logfont ̐ݒ
	lf.lfHeight			= 0;
	lf.lfWidth			= 0;
	lf.lfEscapement		= 0;
	lf.lfOrientation	= 0;
	lf.lfWeight			= FW_NORMAL;
	lf.lfItalic			= FALSE;
	lf.lfUnderline		= FALSE;
	lf.lfStrikeOut		= FALSE;
	lf.lfCharSet		= CharSet;
	lf.lfOutPrecision	= OUT_TT_ONLY_PRECIS;
	lf.lfClipPrecision	= CLIP_DEFAULT_PRECIS;
	lf.lfPitchAndFamily	= FF_DONTCARE | DEFAULT_PITCH;
	strcpy(lf.lfFaceName, szFaceName);

	// tHgI
	hFont = CreateFontIndirect( &lf );	if (hFont==0)  { ReleaseDC(NULL, hDC); return false; }
	hOldFont = (HFONT)SelectObject (hDC, hFont);

	bool flg = false;
	GLuint list_idx = glGenLists(1);
	if (list_idx != 0) {
		GLYPHMETRICSFLOAT  gmf;

		// AEgCtHg̃|S̃fBXvCXg𐶐
		int format = (bPolygon) ? WGL_FONT_POLYGONS : WGL_FONT_LINES;
		BOOL res = wglUseFontOutlines(hDC, code, 1, list_idx, 0.0f, 0.0f, format, &gmf);
		
		// IȂ΃f[^x[Xɓo^
		if (res==TRUE) {
			glyph_info  gd;
			gd.disp_list_idx = list_idx;
			gd.BlackBoxX = gmf.gmfBlackBoxX;
			gd.BlackBoxY = gmf.gmfBlackBoxY;
			gd.CellIncX  = gmf.gmfCellIncX;
			gd.CellIncY  = 1;
			gi[code] = gd;		// QƗp̃}bvɓo^
			flg = true;
		} else {
			glDeleteLists(list_idx, 1);
			DWORD err = GetLastError();
		}
	}

	DeleteObject( (HFONT)SelectObject(hDC, hOldFont) );
	ReleaseDC(NULL, hDC);
	return flg;
}


//-- ܂o^ĂȂΓo^
template <class T>
bool
wglFont<T>::regist_if_not(const T& code)
{
	map<T, glyph_info>::iterator it = gi.find(code);

	// ̕o^ĂȂꍇ͓o^
	if (it==gi.end()) {
		if ( !regist(code) )  return false;
		it = gi.find(code);
	}
	return true;
}


//-- P\
template <class T>
void
wglFont<T>::draw_char(const T& code)
{
	if (!regist_if_not(code))  return;

	map<T, glyph_info>::iterator it = gi.find(code);
	glCallList( it->second.disp_list_idx);
}

//-- P̃̕Ot̃TCY𓾂
template <class T>
void
wglFont<T>::get_glyph_size(const T& code, float& w, float& h)
{
	if (!regist_if_not(code))  return;

	map<T, glyph_info>::iterator it = gi.find(code);
	w = it->second.CellIncX;
	h = it->second.CellIncY;
}

template <class T>
void
wglFont<T>::get_glyph_size2(const T& code, float& w, float& h)
{
	if (!regist_if_not(code))  return;

	map<T, glyph_info>::iterator it = gi.find(code);
	w = it->second.BlackBoxX;
	h = it->second.BlackBoxY;
}


//-- Special Version
typedef		wglFont<char>		wglFontSB;		// VOoCgEtHg
typedef		wglFont<unsigned>	wglFontMB;		// }`oCgEtHg



//==============
//  tHg
//==============
class wgl_font
{
private:
	wglFontSB		fnt_SB;			// PoCgtHg
	wglFontMB		fnt_MB;			// }`oCgtHg
	bool			bRuby;			// r\邩ǂ
	float			ruby_sz;		// ȓ΃TCY
	float			superscript_sz;	// t̃TCY
	float			subscript_sz;	// t̃TCY

public:
	wgl_font(const char* szFaceNameSB, const char* szFaceNameMB) : 
		fnt_SB(szFaceNameSB), fnt_MB(szFaceNameMB), bRuby(true), ruby_sz(0.3f),
		superscript_sz(0.6f), subscript_sz(0.6f)  {};

	void  set_facename_SB(const char* szFaceNameSB)	{ fnt_SB.set_face_name(szFaceNameSB); }
	void  set_facename_MB(const char* szFaceNameMB)	{ fnt_MB.set_face_name(szFaceNameMB); }

	void  set_ruby_size(float sz)	{ ruby_sz = sz; }
	void  enable_ruby(bool flg)		{ bRuby = flg; }
	void  set_superscript_size(float sz)	{ superscript_sz = sz; }
	float get_superscript_size() const		{ return superscript_sz; }

	// Single-byte character
	void		draw_char_SB(char ch);
	void		get_glyph_size_SB(char ch, float& w, float& h);

	// Multi-byte character
	void		draw_char_MB(char ch1, char ch2);
	void		get_glyph_size_MB(char ch1, char ch2, float& w, float& h);

	// Special char
	void		draw_Copyright();

	// Draw Text
	void  draw_text(const char* str, float D);							// \
	void  draw_text(const char* str) { draw_text(str, 0.0f); }
	void  draw_textf(const char* szFormat, ...);						// t\
	void  prepare_centering(const char* str);							// ŕ\
	void  prepare_flushright(const char* str);							// E񂹂ŕ\
	void  draw_per_capita_basis(float w, const char* str);				// ϓŕ\
	void  draw_superscript(const char* p);								// t
	void  draw_subscript(const char* p);								// t
	void  draw_special_char(const char* p);								// ꕶ
	int	  get_text_size(const char* str, float& w0, float& h);
};


// Single-Byte character
inline  void
wgl_font::draw_char_SB(char ch)
{
	fnt_SB.draw_char(ch);
}

inline  void
wgl_font::get_glyph_size_SB(char ch, float& w, float& h)
{
	fnt_SB.get_glyph_size(ch, w, h);
}


// Multi-Byte character
inline  void
wgl_font::draw_char_MB(char ch1, char ch2)
{
	fnt_MB.draw_char( get_MB_code(ch1, ch2) ); 
}

inline 	void
wgl_font::get_glyph_size_MB(char ch1, char ch2, float& w, float& h)
{
	fnt_MB.get_glyph_size( get_MB_code(ch1, ch2), w, h);
}


#endif
