/******************************************************************************

Copyright (c) 2007   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEF
Avj̕擾邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ
܂Bɂ́A\tgEFA̕gpAʁAύXAAfځAЕzATu
CZXA/܂͔̔錠Aу\tgEFA񋟂鑊ɓ
Ƃ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕ
Lڂ̂Ƃ܂B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂
񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KAьN
QɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂܂B ҂܂͒
쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\tgEFAɋN܂
֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
*******************************************************************************/
#include  <string.h>
#include  "Constellation.h"


//-----------------
//  Constellation
//-----------------
const static char ConstellationAbbr[88][4] = {
	"And", "Mon", "Sgr", "Del", "Ind",
	"Psc", "Lep", "Boo", "Hya", "Eri",
	"Tau", "CMa", "Lup", "UMa", "Vir",
	"Ari", "Ori", "Pic", "Cas", "Dor",
	"Cnc", "Com", "Cha", "Crv", "CrB",
	"Tuc", "Aur", "Cam", "Pav", "Cet",
	"Cep", "Cen", "Mic", "CMi", "Equ",
	"Vul", "UMi", "LMi", "Crt", "Lyr",
	"Cir", "Ara", "Sco", "Tri", "Leo",
	"Nor", "Sct", "Cae", "Scl", "Gru",
	"Men", "Lib", "Lac", "Hor", "Vol",
	"Pup", "Mus", "Cyg", "Oct", "Col",
	"Aps", "Gem", "Peg", "Ser", "Oph",
	"Her", "Per", "Vel", "Tel", "Phe",
	"Ant", "Aqr", "Hyi", "Cru", "PsA",
	"CrA", "TrA", "Sge", "Cap", "Lyn",
	"Pyx", "Dra", "Car", "CVn", "Ret",
	"For", "Sex", "Aql"
};


int
get_constellation_ID(const char* str) {
	for (int i=0; i<88; i++) {
		if (stricmp(str, ConstellationAbbr[i])==0)  return i;
	}
	return CNST_NONE;
}


const char*
get_constellation_abbr(const int CnstID) {
	if (CnstID >= 88)  return 0;
	return  ConstellationAbbr[CnstID];
}
